package net.ME1312.SubServers.Host.API.Event;

import net.ME1312.SubServers.Host.Library.Util;
import net.ME1312.SubServers.Host.Library.Event.Event;

import java.util.UUID;

/**
 * Add Server Event
 */
public class SubAddHostEvent extends Event {
    private UUID player;
    private String host;

    /**
     * Server Add Event
     *
     * @param player Player Adding Server
     * @param host Host to be added
     */
    public SubAddHostEvent(UUID player, String host) {
        if (Util.isNull(host)) throw new NullPointerException();
        this.player = player;
        this.host = host;
    }

    /**
     * Gets the Host to be Added
     *
     * @return The Host to be Added
     */
    public String getHost() { return host; }

    /**
     * Gets the player that triggered the Event
     *
     * @return The Player that triggered this Event or null if Console
     */
    public UUID getPlayer() { return player; }
}
